summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 2986c02)
raw | patch | inline | side by side (parent: 2986c02)
author | Junio C Hamano <junkio@cox.net> | |
Thu, 23 Nov 2006 07:15:00 +0000 (23:15 -0800) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Fri, 24 Nov 2006 00:54:54 +0000 (16:54 -0800) |
This adds Andy's refspec glob. You can have a single line:
Pull: refs/heads/*:refs/remotes/origin/*
in your ".git/remotes/origin" and say "git fetch" to retrieve
all refs under heads/ at the remote side to remotes/origin/ in
the local repository.
Signed-off-by: Junio C Hamano <junkio@cox.net>
Pull: refs/heads/*:refs/remotes/origin/*
in your ".git/remotes/origin" and say "git fetch" to retrieve
all refs under heads/ at the remote side to remotes/origin/ in
the local repository.
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-parse-remote.sh | patch | blob | history |
diff --git a/git-parse-remote.sh b/git-parse-remote.sh
index c325ef761e4c558ab5c7c560da942e127e1be040..e281b7c6ebd5515d74201869574eed6077f37c9d 100755 (executable)
--- a/git-parse-remote.sh
+++ b/git-parse-remote.sh
esac
}
+# Called from canon_refs_list_for_fetch -d "$remote", which
+# is called from get_remote_default_refs_for_fetch to grok
+# refspecs that are retrieved from the configuration, but not
+# from get_remote_refs_for_fetch when it deals with refspecs
+# supplied on the command line. $ls_remote_result has the list
+# of refs available at remote.
+expand_refs_wildcard () {
+ for ref
+ do
+ # a non glob pattern is given back as-is.
+ expr "z$ref" : 'zrefs/.*/\*:refs/.*/\*$' >/dev/null || {
+ echo "$ref"
+ continue
+ }
+ from=`expr "z$ref" : 'z\(refs/.*/\)\*:refs/.*/\*$'`
+ to=`expr "z$ref" : 'zrefs/.*/\*:\(refs/.*/\)\*$'`
+ echo "$ls_remote_result" |
+ (
+ IFS=' '
+ while read sha1 name
+ do
+ mapped=${name#"$from"}
+ if test "z$name" != "z${name#'^{}'}" ||
+ test "z$name" = "z$mapped"
+ then
+ continue
+ fi
+ echo "${name}:${to}${mapped}"
+ done
+ )
+ done
+}
+
# Subroutine to canonicalize remote:local notation.
canon_refs_list_for_fetch () {
# If called from get_remote_default_refs_for_fetch
merge_branches=$(git-repo-config \
--get-all "branch.${curr_branch}.merge")
fi
+ set x $(expand_refs_wildcard "$@")
+ shift
fi
for ref
do